/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2004
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1H.lib E1.46a [13 May 2005]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "port.h"
#include "watchdogtimer.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
	int		keta1;
	int		keta2;
	int		kotae1;
	int		kotae2;
	int		hyouji_p;
	
	unsigned short	ad_data;		/* ADł̎擾l			*/


char	led_data[14]=
			{0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x27,0x7f,0x6f,0x00,0x5c,0x54,0x48};
			/*led_data[10]=" ",[11]="o",[12]="=n",[13]="="*/

void	led_port_clear(void)
{
	P4.0=1;
	P4.1=1;
	P4.2=1;
	P4.3=1;
}

void	time_wait(long time)
{
	while(time!=0){
	time--;
	}
}

void	led_7seg_out(int data)
{
	P2=(P2|0x0c)&(~(led_data[data]&0x03)<<2);
	P12=(P12|0x0e)&(~(led_data[data]&0x1c)>>1);
	P3=(P3|0x03)&(~(led_data[data]&0x60)>>5);
}

void	led_disp(void)
{
	led_port_clear();
	led_7seg_out(keta1);
	P4.0=0;
	time_wait(200);
	led_port_clear();
	led_7seg_out(keta2);
	P4.1=0;
	time_wait(200);
	led_port_clear();
	led_7seg_out(kotae1);
	P4.2=0;
	time_wait(200);
	led_port_clear();
	led_7seg_out(kotae2);
	P4.3=0;
	time_wait(200);
	led_port_clear();
}
int		key_scan(void)
{
int	key_no;

	AD_Start(ADChannel0);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=1;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=2;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=3;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=4;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=5;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=6;
	}

	if(key_no!=255){return key_no;}

	AD_Start(ADChannel1);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=7;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=8;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=9;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=10;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=0;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=11;
	}

	return key_no;

}

void	suji_set(int key)
{
	switch(hyouji_p){
		case 0:keta1=key;hyouji_p=1;break;
		case 1:keta2=key;hyouji_p=2;break;
		case 2:kotae1=kotae2;
				if(kotae1==0){kotae1=10;}
				kotae2=key;break;
		case 3:kotae1=10;
				kotae2=key;
				hyouji_p=2;break;
		case 4:keta1=key;
				keta2=10;
				kotae1=10;
				kotae2=10;
				hyouji_p=1;break;
	}
}

void	kotae_check(void)
{
	int		check1;
	int		check2;
	int		kotae_c;
	int		kotae_m;
	
		check1=kotae1;
		if(check1==10){check1=0;}
		check2=kotae2;
		if(check2==10){check2=0;}
		kotae_c=check1*10+check2;
		kotae_m=keta1*keta2;
		if(kotae_c==kotae_m){
			kotae1=11;
			kotae2=11;
			hyouji_p=4;
		}
		else{
			kotae1=13;
			kotae2=13;
			hyouji_p=3;
		}
}

void 	main( void )
{

	int		scan_key1;
	int		scan_key2;
	int		scan_f;

	keta1=9;
	keta2=9;
	kotae1=8;
	kotae2=1;
	scan_f=0;
	hyouji_p=4;

	/* TODO. add user code */
	while(1){
	
		scan_key1=key_scan();
		led_disp();
		scan_key2=key_scan();
		if(scan_key1==scan_key2){
			if(scan_key1!=255){
				if(scan_f==0){
						switch(scan_key1){
							case 10:hyouji_p=0;keta1=10;keta2=10;
									kotae1=10;kotae2=10;break;
							case 11:if(hyouji_p==2){
									kotae_check();
									}
									break;
							case 0:
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:	suji_set(scan_key1);
									break;
						}
						scan_f=1;
				}
			}
		}
		else{
			scan_f=0;
		}
	
	}
}

